@REM 
@REM Copyright (C) 2010, Freescale Semiconductor, Inc. All Rights Reserved.
@REM THIS SOURCE CODE, AND ITS USE AND DISTRIBUTION, IS SUBJECT TO THE TERMS
@REM AND CONDITIONS OF THE APPLICABLE LICENSE AGREEMENT 
@REM 
@echo off & setlocal EnableDelayedExpansion

@REM Skip the processing with debug build
if "%WINCEDEBUG%"=="debug" goto end_of_file

@REM Set path variables
set _TARGETIMGDIR=%_TARGETPLATROOT%\target\%_TGTCPU%\%WINCEDEBUG%

@REM Save current dir and goto tool dir
set _CURRENTDIR=%CD%

set _SUPPORT=SUPPORT
set/a _FOUND_PDK=0

@REM Check if it's PDK version 
for /l %%i in (0,1,50) do if "!_TGTPLAT:~%%i,3!"=="PDK" set strstart=%%i && set/a _FOUND_PDK=1

if %_FOUND_PDK% EQU 1 (
    for /l %%i in (0,1,50) do if "!_TGTPLAT:~%%i,1!"=="" set strlen=%%i && goto :_end_for     
:_end_for
    set/a strlen=%strlen%-1
    @REM echo strstart=%strstart% strlen=%strlen%
    set _SUPPORT=SUPPORT_
    for /l %%i in (%strstart%,1,%strlen%) do (
        set _SUPPORT=!_SUPPORT!!_TGTPLAT:~%%i,1!
    )
) 
set _TOOLDIR=%_TARGETPLATROOT%\TOOL\SBIMAGE

if not exist %_TOOLDIR%\elftosb.exe goto file_not_exist

cd %_TOOLDIR%

@REM Copy xldr.nb0 and nk.nb0
rem copy /Y %_TARGETIMGDIR%\xldr.nb0
copy /Y %_FLATRELEASEDIR%\nk.nb0

@REM Generate nk.sb
elftosb -z -c nk.bd -o nk.sb
elftosb -z -f imx28 -c nk_ivt.bd -o nk_ivt.sb

@REM Copy nk.sb to flat release directory
copy /Y nk.sb %_FLATRELEASEDIR%
copy /Y nk_ivt.sb %_FLATRELEASEDIR%

@REM Clean up ...
rem del xldr.nb0
del nk.nb0

@REM Go back to saved dir
cd %_CURRENTDIR%

set _TOOLDIR=%_TARGETPLATROOT%\TOOL\COMMON\FixNK

if not exist %_TOOLDIR%\fixnk.exe goto file_not_exist

cd %_TOOLDIR%

viewbin %_FLATRELEASEDIR%\nk.bin > nkinfo.txt
fixnk %_FLATRELEASEDIR%\nk.nb0 nkinfo.txt 

@REM Clean up ...
del nkinfo.txt

@REM Go back to saved dir
cd %_CURRENTDIR%

goto end_of_file

:file_not_exist
echo ERROR : %_TOOLDIR% does not exist, please copy this folder from BSP package.

:end_of_file
