//-----------------------------------------------------------------------------
//
//  Copyright (C) 2007-2010, Freescale Semiconductor, Inc. All Rights Reserved.
//  THIS SOURCE CODE, AND ITS USE AND DISTRIBUTION, IS SUBJECT TO THE TERMS
//  AND CONDITIONS OF THE APPLICABLE LICENSE AGREEMENT
//
//------------------------------------------------------------------------------
//
//  File:  ioctl_tab.h
//
//  Configuration file for the OAL IOCTL component.
//
//  This file is included by the platform's ioctl.c file and defines the
//  global IOCTL table, g_oalIoCtlTable[]. Therefore, this file may ONLY
//  define OAL_IOCTL_HANDLER entries.
//
// IOCTL CODE,                          Flags   Handler Function
//------------------------------------------------------------------------------

#include <oal_ioctl_tab.h>

#ifdef OAL_ILTIMING
{ IOCTL_HAL_ILTIMING,                    0,  OALIoCtlHalILTiming         },
#endif
{ IOCTL_HAL_POSTINIT,                    0,  OALIoCtlHalPostInit         },
{ IOCTL_HAL_PRESUSPEND,                  0,  OALIoCtlHalPresuspend       },
{ IOCTL_HAL_GET_HWENTROPY,               0,  OALIoCtlHalGetHWEntropy     },
{ IOCTL_KITL_GET_INFO,                   0,  OALIoCtlKitlGetInfo         },
{ IOCTL_HAL_POWER_OFF_ENABLE,            0,  OALIoCtlPowerOffEnable      },
{ IOCTL_HAL_QUERY_BOARD_ID,              0,  OALIoCtlQueryBoardId        },
{ IOCTL_HAL_QUERY_BOOT_MODE,             0,  OALIoCtlQueryBootMode       },
{ IOCTL_HAL_SET_BOOT_SOURCE,             0,  OALIoCtlSetBootSource       },
{ IOCTL_HAL_QUERY_UPDATE_SIG,            0,  OALIoCtlQueryUpdateSig      },
{ IOCTL_HAL_SET_UPDATE_SIG,              0,  OALIoCtlSetUpdateSig        },
{ IOCTL_HAL_BEEP,              			 0,  OALIoCtlBeep                },
{ IOCTL_HAL_CHECK_DEBUG,				 0,  OALIoCheckDebug			 },
{ IOCTL_HAL_GET_HIVE_CLEAN_FLAG, 		 0,  OALIoCtlGetCleanFlag        },
{ 0,                                     0,  NULL                        } // Terminator
