// CoreClk.cpp : Defines the entry point for the DLL application.
//

/********************************************
 * 
 ********************************************
 *
 *
 *
 */

#include "stdafx.h"
#include "DBGENA.h"
#include <cpl.h>
#include <ceddk.h>

#pragma warning(disable: 4100)

#ifndef align
#define align(x)
#endif

void SaveRegistryData( DWORD Trait ) 
{
    LONG  regError;
    HKEY  hKey;
    DWORD dwDataSize;
	
    // Open the registry key
    regError = RegOpenKeyEx(HKEY_LOCAL_MACHINE,TEXT("Drivers\\BuiltIn\\COM3"),0,0,&hKey);
    if (regError != ERROR_SUCCESS)
    {
        RETAILMSG(1,(TEXT("Failed opening HKEY_LOCAL_MACHINE\\Drivers\\BuiltIn\\COM3\r\n")));
        return;
    }

    dwDataSize = sizeof(DWORD);
    regError = RegSetValueEx(hKey,L"dbgSerial", NULL, REG_DWORD,(LPBYTE)&Trait,sizeof(DWORD) );
	RegCloseKey(hKey);

	
	RETAILMSG(1,(TEXT("Registry write <regError=%d> ... dbgSerial=%d \r\n"), regError, Trait));
}

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


BOOL CALLBACK cbCPlMainProc(HWND,UINT,WPARAM,LPARAM);

static HMODULE	ghInst;
static WCHAR	gTextBuf[2048];

///////////////////////////////////////////////////////////////////////////////
//
// Function:
//		CPlApplet
// Purpose:
//		Dispatcher Entry
//
LONG APIENTRY CPlApplet(
    HWND hwndCPl,
    UINT uMsg,
    LPARAM lParam1,
    LPARAM lParam2
) 
{

	LPCPLINFO CPlInfo;
	LPNEWCPLINFO pCplInfo;
	
	switch (uMsg) {

		case CPL_INIT:

			ghInst = GetModuleHandle(TEXT("DbgEna.cpl")); // get's Instance Handle			
			return TRUE;

		case CPL_GETCOUNT:			
			return 1; // we provide a single Dialog (this version)

		case CPL_NEWINQUIRE:
	
			ASSERT(lParam1 == 0);
			pCplInfo = (NEWCPLINFO *)lParam2;
			pCplInfo->dwSize = sizeof(NEWCPLINFO);
			pCplInfo->dwFlags = 0;
			pCplInfo->dwHelpContext = 0;
			pCplInfo->lData = IDI_ICON_SMALL;
			pCplInfo->hIcon = LoadIcon(ghInst, MAKEINTRESOURCE(IDI_ICON));
			LoadString(ghInst, IDS_CPLNAME_GER, pCplInfo->szName, sizeof(pCplInfo->szName)/sizeof(pCplInfo->szName[0]));
			LoadString(ghInst, IDS_CPLINFO_GER, pCplInfo->szInfo, sizeof(pCplInfo->szInfo)/sizeof(pCplInfo->szInfo[0]));			
			pCplInfo->szHelpFile[0] = L'\0';
			break;

		case CPL_INQUIRE:			
			CPlInfo = (LPCPLINFO)lParam2; // support the calling app with all the neccesary knowledge
			CPlInfo->idIcon = IDI_ICON;
			CPlInfo->idName = IDS_CPLNAME_GER;
			CPlInfo->idInfo = IDS_CPLINFO_GER;
			break;

		case CPL_DBLCLK:
			DialogBox(ghInst, MAKEINTRESOURCE(IDD_CPLMAINDLG), hwndCPl, cbCPlMainProc); // create & show the dialog
			break;

		case CPL_STOP:
			break;

		case CPL_EXIT:
			break;

		default:
			break;

	}

	return 0;
}
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\//

///////////////////////////////////////////////////////////////////////////////
//
// Function:
//		cbCPlMainProc
// Purpose:
//		Dispatcher for DialogWindow Messages
//
BOOL CALLBACK cbCPlMainProc(
	HWND hwndDlg,  // handle to dialog box
	UINT uMsg,     // message
	WPARAM wParam, // first message parameter
	LPARAM lParam  // second message parameter
)
{
	static HBITMAP hBitmap;
	switch (uMsg) {
		case WM_CLOSE:
			SendMessage(hwndDlg, WM_COMMAND, IDOK, (LPARAM)GetDlgItem(hwndDlg, IDOK));
			break;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDOK:
					SaveRegistryData(1);
					EndDialog(hwndDlg, TRUE);
					break;
				case IDCANCEL:
					SaveRegistryData(0);
					EndDialog(hwndDlg, TRUE);
					break;
			}
			break;
		
		default:;			
	}
	return 0;
}
//\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\//



