
#pragma warning(disable: 4115 4201 4204 4100)
#include <windows.h>
#include "bsp.h"
#include "bsp_gpio.h"
#include "bsp_version.h"


GPIO_LEVEL gpio;
const WCHAR pin_name[17][16] = { L"GPOUT1", L"GPOUT2", L"GPOUT3", L"GPOUT4", L"GPOUT5", L"GPOUT6", L"GPOUT7", L"GPOUT8", 
						 	     L"GPI1", L"GPI2", L"GPI3", L"GPI4", L"USER_LED1", L"USER_LED2", L"LD_BKL_ON", L"LCD_LVDS_ENA", L"OVERTEMP" };
int WINAPI WinMain(
    HINSTANCE hInstance, 
    HINSTANCE hPrevInstance, 
    LPWSTR lpszCmdLine,
    int nCmdShow)
{
	HANDLE 						h;
	DRV_VERSION_INFORMATION		v;
	DWORD						dummy;
	unsigned char				f;
	int 						t;

	if ( 1 < swscanf(lpszCmdLine, L"%c %d %d", &f, &gpio.pin, &gpio.level) ) {
		RETAILMSG(1,(TEXT(" Syntax: testgpio \r\n")));
		RETAILMSG(1,(TEXT("         testgpio <r> <pin>\r\n")));
		RETAILMSG(1,(TEXT("         testgpio <w> <pin> <level>\r\n")));		
	}
	
	RETAILMSG(1,(TEXT("Open GPI1:  ...\r\n")));

	h = CreateFile(L"GPI1:", GENERIC_READ | GENERIC_WRITE,0,	NULL,OPEN_EXISTING,	0,NULL);	

	if ( DeviceIoControl(h, IOCTL_XXX_GETVERSIONINFO,  NULL,  0, &v, sizeof(v), &dummy, 0) ) {
		RETAILMSG(1,(TEXT("Versionsinformation:\r\n")));
		RETAILMSG(1,(TEXT("   Name: %S\r\n"), v.cName));
		RETAILMSG(1,(TEXT("   Build: %S\r\n"), v.cBuild));
		RETAILMSG(1,(TEXT("   Version: 0x%x\r\n"), v.ulVersion));
	} else {
		RETAILMSG(1,(TEXT("Versionsinformation kann nicht gelesen werden !!!!\r\n")));
	}

	if (( f == 'r' ) || ( f == 'R')) {
		if ( DeviceIoControl(h, IOCTL_GET_LEVEL,  &gpio,  sizeof(gpio), &gpio,  sizeof(gpio), &dummy, 0) )
			RETAILMSG(1,(TEXT("pin %s (%d) level = %d\r\n"), pin_name[gpio.pin], gpio.pin, gpio.level));
		else
			RETAILMSG(1,(TEXT("Fehler beim lesen von pin = %d\r\n"), gpio.pin));
	} else {
		if (( f == 'w' ) || ( f == 'W')) {
			if ( DeviceIoControl(h, IOCTL_SET_LEVEL,  &gpio,  sizeof(gpio), NULL, 0, NULL, 0) )
				RETAILMSG(1,(TEXT("Setzte Pin %d auf %d \r\n"), gpio.pin, gpio.level));
			else
				RETAILMSG(1,(TEXT("Fehler beim schreiben von pin = %d\r\n"), gpio.pin));
		} else 	{
			for (t=0; t<17; t++) {
				gpio.pin = t;
				if ( DeviceIoControl(h, IOCTL_GET_LEVEL,  &gpio,  sizeof(gpio), &gpio,  sizeof(gpio), &dummy, 0) )
					RETAILMSG(1,(TEXT("pin %s (%d) level = %d\r\n"), pin_name[gpio.pin], gpio.pin, gpio.level));
				else
					RETAILMSG(1,(TEXT("Fehler beim lesen von pin = %d\r\n"), gpio.pin));				
			}
		}
	}
	
	
	
	RETAILMSG(1,(TEXT("-- done\r\n")));	
	
	CloseHandle(h);
	return 0;
}