
#pragma warning(disable: 4115 4201 4204 4100 4101)
#include <windows.h>
#include "bsp.h"
#include "bsp_buzzer.h"
#include "bsp_version.h"

int WINAPI WinMain(
    HINSTANCE hInstance, 
    HINSTANCE hPrevInstance, 
    LPWSTR lpszCmdLine,
    int nCmdShow)
{
	HANDLE h;
	UCHAR test[8*1024];
	UCHAR help[2];
	BOOL bRet;
	DWORD dwRead, dwWritten, t;
	DWORD						dummy;
	
	DRV_VERSION_INFORMATION		v;
	
	RETAILMSG(1,(TEXT("Open EPR1: ...")));

	h = CreateFile(L"EPR1:", GENERIC_READ | GENERIC_WRITE,0,	NULL,OPEN_EXISTING,	0,NULL);	

	if ( DeviceIoControl(h, IOCTL_XXX_GETVERSIONINFO,  NULL,  0, &v, sizeof(v), &dummy, 0) ) {
		RETAILMSG(1,(TEXT("Versionsinformation:\r\n")));
		RETAILMSG(1,(TEXT("   Name: %S\r\n"), v.cName));
		RETAILMSG(1,(TEXT("   Build: %S\r\n"), v.cBuild));
		RETAILMSG(1,(TEXT("   Version: 0x%x\r\n"), v.ulVersion));
	} else {
		RETAILMSG(1,(TEXT("Versionsinformation kann nicht gelesen werden !!!!\r\n")));
	}
	
	RETAILMSG(1,(TEXT("EEPROM-Size: %d \r\n"), SetFilePointer(h, 0, 0, FILE_END ) ));
	
	

	
	SetFilePointer(h, 0, 0, FILE_BEGIN );
	
	RETAILMSG(1,(TEXT("Call ReadFile \r\n")));

	bRet = ReadFile ( h, test, 1024, &dwRead, NULL);
	RETAILMSG(1,(TEXT("rd: ")));
	for (t=0; t<1024; t++)
		RETAILMSG(1,(TEXT("0x%02x "), test[t] ));
	RETAILMSG(1,(TEXT("\r\n\r\n")));
		
	dwRead = GetTickCount();
	RETAILMSG(1,(TEXT("next start at (msek) = 0x%02x\r\nwr: "), dwRead ));		
	for (t=0; t<1024; t++) {
		test[t] = (UCHAR)dwRead++;
		RETAILMSG(1,(TEXT("0x%02x "), test[t] ));
	}

	SetFilePointer(h, 0, 0, FILE_BEGIN );
	
	bRet = WriteFile ( h, test, 1024, &dwWritten , 0);
	RETAILMSG(1,(TEXT(" WriteFile returns 0x%x\r\n"), bRet));
	
	RETAILMSG(1,(TEXT("Call ReadFile \r\n")));
	memset(test, 0, 1024);
	SetFilePointer(h, 0, 0, FILE_BEGIN );
	bRet = ReadFile ( h, test, 1024, &dwRead, NULL);
	
	RETAILMSG(1,(TEXT("rd: ")));
	for (t=0; t<1024; t++)
		RETAILMSG(1,(TEXT("0x%02x "), test[t] ));
	RETAILMSG(1,(TEXT("\r\n\r\n rd:")));	

	
	for (t=0; t<10; t++) {
		SetFilePointer(h, t, 0, FILE_BEGIN );
		bRet = ReadFile ( h, help, 1, &dwRead, NULL);
		RETAILMSG(1,(TEXT("0x%x "), help[0] ));
	}
	
	RETAILMSG(1,(TEXT("\r\n\r\n wr:")));	
	SetFilePointer(h, 20, 0, FILE_BEGIN );
	for (t=0; t<10; t++) {
		test[0] = (UCHAR)t;
		bRet = WriteFile ( h, test, 1, &dwWritten , 0);
		RETAILMSG(1,(TEXT("0x%x "), test[0] ));
	}

	RETAILMSG(1,(TEXT("\r\n\r\n rd:")));	
	SetFilePointer(h, 20, 0, FILE_BEGIN );
	for (t=0; t<10; t++) {
		memset(test, 0, 1024);
		bRet = ReadFile ( h, help, 1, &dwRead, NULL);
		RETAILMSG(1,(TEXT("0x%x "), help[0] ));
	}
	
	CloseHandle(h);
	
	return 0;

}