
#pragma warning(disable: 4115 4201 4204 4100)
#include <windows.h>
#include "bsp.h"
#include "bsp_temp.h"
#include "bsp_version.h"



int WINAPI WinMain(
    HINSTANCE hInstance, 
    HINSTANCE hPrevInstance, 
    LPWSTR lpszCmdLine,
    int nCmdShow)
{
	HANDLE 						h;
	DRV_VERSION_INFORMATION		v;
	TEMP_STRUCT					t;
	DWORD						dummy;
	unsigned char				dev;


	if ( 1 > swscanf(lpszCmdLine, L"%d %d %d", &dev, &t.reg, &t.value) ) {
		RETAILMSG(1,(TEXT(" Syntax: testtemp \r\n")));
		RETAILMSG(1,(TEXT("         testtemp <dev> <reg> <dez-value>\r\n")));
		RETAILMSG(1,(TEXT("         		dev=0,1 reg=0,1,2,3\r\n")));
	} else {
		h = CreateFile((dev)?L"TMP2:":L"TMP1:", GENERIC_READ | GENERIC_WRITE,0,	NULL,OPEN_EXISTING,	0,NULL);	
		if ( ! DeviceIoControl(h, IOCTL_SET_TEMP,  &t,  sizeof(t), NULL,  0, &dummy, 0) ) {
			RETAILMSG(1,(TEXT("Error on writing dev=%d reg=%d value=%d\r\n"), dev, t.reg, t.value));
		}
		CloseHandle(h);
	}
	
	RETAILMSG(1,(TEXT("Open TMP1:  ...\r\n")));

	h = CreateFile(L"TMP1:", GENERIC_READ | GENERIC_WRITE,0,	NULL,OPEN_EXISTING,	0,NULL);	
	
	if ( DeviceIoControl(h, IOCTL_XXX_GETVERSIONINFO,  NULL,  0, &v, sizeof(v), &dummy, 0) ) {
		RETAILMSG(1,(TEXT("Versionsinformation:\r\n")));
		RETAILMSG(1,(TEXT("   Name: %S\r\n"), v.cName));
		RETAILMSG(1,(TEXT("   Build: %S\r\n"), v.cBuild));
		RETAILMSG(1,(TEXT("   Version: 0x%x\r\n"), v.ulVersion));
	} else {
		RETAILMSG(1,(TEXT("Versionsinformation kann nicht gelesen werden !!!!\r\n")));
	}

	t.reg = 4;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )	
	{
		RETAILMSG(1,(TEXT("  Control/Status Reg = 0x%x\r\n"), t.value ));
		RETAILMSG(1,(TEXT("      ==> resolution = %d bit (with sign) \r\n"), ( ( t.value >> 5 ) & 0x03 ) + 11));
	}
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));
	

	t.reg = 0;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )
		RETAILMSG(1,(TEXT("  Temp              = %d *10C\r\n"), (short)t.value  ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));
	t.reg = 1;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )
		RETAILMSG(1,(TEXT("  Configuration Reg = 0x%x\r\n"), (short)t.value ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));	
	t.reg = 2;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )
		RETAILMSG(1,(TEXT("  Temp(hyst)        = %d *10C\r\n"), (short)t.value  ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));	
	t.reg = 3;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )	
		RETAILMSG(1,(TEXT("  Temp (os)         = %d *10C\r\n"), (short)t.value  ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));

	RETAILMSG(1,(TEXT("-- done\r\n")));	
	
	CloseHandle(h);
	
	RETAILMSG(1,(TEXT("Open TMP2:  ...\r\n")));

	h = CreateFile(L"TMP2:", GENERIC_READ | GENERIC_WRITE,0,	NULL,OPEN_EXISTING,	0,NULL);	

	if ( DeviceIoControl(h, IOCTL_XXX_GETVERSIONINFO,  NULL,  0, &v, sizeof(v), &dummy, 0) ) {
		RETAILMSG(1,(TEXT("Versionsinformation:\r\n")));
		RETAILMSG(1,(TEXT("   Name: %S\r\n"), v.cName));
		RETAILMSG(1,(TEXT("   Build: %S\r\n"), v.cBuild));
		RETAILMSG(1,(TEXT("   Version: 0x%x\r\n"), v.ulVersion));
	} else {
		RETAILMSG(1,(TEXT("Versionsinformation kann nicht gelesen werden !!!!\r\n")));
	}
	t.reg = 4;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )	
	{
		RETAILMSG(1,(TEXT("  Control/Status Reg = 0x%x\r\n"), t.value ));
		RETAILMSG(1,(TEXT("      ==> resolution = %d bit (with sign) \r\n"), ( ( t.value >> 5 ) & 0x03 ) + 11));
	}
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));
	
	t.reg = 0;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )
		RETAILMSG(1,(TEXT("  Temp              = %d *10C\r\n"), (short)t.value  ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));
	t.reg = 1;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )
		RETAILMSG(1,(TEXT("  Configuration Reg = 0x%x\r\n"), t.value ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));	
	t.reg = 2;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )
		RETAILMSG(1,(TEXT("  Temp(hyst)        = %d *10C\r\n"), (short)t.value  ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));	
	t.reg = 3;
	if ( DeviceIoControl(h, IOCTL_GET_TEMP,  &t,  sizeof(t), &t,  sizeof(t), &dummy, 0) )	
		RETAILMSG(1,(TEXT("  Temp (os)         = %d *10C\r\n"), (short)t.value  ));
	else
		RETAILMSG(1,(TEXT("fehler !!\r\n")));

	
	RETAILMSG(1,(TEXT("-- done\r\n")));	
	
	CloseHandle(h);	
	return 0;
}