
#pragma warning(disable: 4115 4201 4204 4100 4101)
#include <windows.h>
#include "bsp.h"
#include "bsp_buzzer.h"
#include "bsp_version.h"

int WINAPI WinMain(
    HINSTANCE hInstance, 
    HINSTANCE hPrevInstance, 
    LPWSTR lpszCmdLine,
    int nCmdShow)
{
	HANDLE h;
	UCHAR test[20];
	BOOL bRet;
	DWORD dwRead, dwWritten, t;
	DWORD						dummy;
	
	DRV_VERSION_INFORMATION		v;
	
	RETAILMSG(1,(TEXT("WriteMAC\r\n\r\n")));
	RETAILMSG(1,(TEXT("    WriteMAC --- MAC auslesen \r\n")));
	RETAILMSG(1,(TEXT("    WriteMAC abcdefgh --- MAC schreiben \r\n")));
	RETAILMSG(1,(TEXT("    ... verarbeite WriteMAC %s \r\n\r\n"), lpszCmdLine));
	
	RETAILMSG(1,(TEXT("Open EPR1: ...")));

	h = CreateFile(L"EPR1:", GENERIC_READ | GENERIC_WRITE,0,	NULL,OPEN_EXISTING,	0,NULL);	

	if ( DeviceIoControl(h, IOCTL_XXX_GETVERSIONINFO,  NULL,  0, &v, sizeof(v), &dummy, 0) ) {
		RETAILMSG(1,(TEXT("Versionsinformation:\r\n")));
		RETAILMSG(1,(TEXT("   Name: %S\r\n"), v.cName));
		RETAILMSG(1,(TEXT("   Build: %S\r\n"), v.cBuild));
		RETAILMSG(1,(TEXT("   Version: 0x%x\r\n"), v.ulVersion));
	} else {
		RETAILMSG(1,(TEXT("Versionsinformation kann nicht gelesen werden !!!!\r\n")));
	}
	
	RETAILMSG(1,(TEXT("EEPROM-Size: %d \r\n"), 1+SetFilePointer(h, 0, 0, FILE_END ) ));
	

	SetFilePointer(h, 0x50, 0, FILE_BEGIN );
	
	if ( !lpszCmdLine[0] ) {
		bRet = ReadFile ( h, test, 8, &dwRead, NULL);
		for ( t = 0; t<8; t++ )
			if ( ( test[t] < 0x30 ) || ( test[t] > 102 ) ){
				RETAILMSG(1,(TEXT("\r\nUngueltige mac !!!!\r\n")));
				memset(test, 0x20, 8);
				break;
			}
		RETAILMSG(1,(TEXT("READ: (0xd0:0x93):%c%c:%c%c:%c%c:%c%c\r\n\r\n"), 	test[0], test[1], test[2], test[3], 
																				test[4], test[5], test[6], test[7] ));	
	} else {
		// DEFAULT
		memset(test, 0x30, 8);
		for ( t = 0; lpszCmdLine[t] && (t<8); t++)
			test[t] = (UCHAR)lpszCmdLine[t]; 
			
		RETAILMSG(1,(TEXT("WRITE: (0xd0:0x93):%c%c:%c%c:%c%c:%c%c\r\n\r\n"), 	test[0], test[1], test[2], test[3], 
																				test[4], test[5], test[6], test[7] ));				
		bRet = WriteFile ( h, test, 8, &dwWritten , 0);
	}
	CloseHandle(h);
	
	return 0;

}