//------------------------------------------------------------------------------
//
//  Copyright (C) 2009, Freescale Semiconductor, Inc. All Rights Reserved.
//  THIS SOURCE CODE, AND ITS USE AND DISTRIBUTION, IS SUBJECT TO THE TERMS
//  AND CONDITIONS OF THE APPLICABLE LICENSE AGREEMENT
//
//------------------------------------------------------------------------------
// UpdateImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "UpdateImage.h"
#include "UpdateImageDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

HANDLE hThread;

// CUpdateImageDlg dialog

CUpdateImageDlg::CUpdateImageDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CUpdateImageDlg::IDD, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUpdateImageDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_PROGRESS1, m_process);
    DDX_Control(pDX, IDC_EDIT2, m_static);
    DDX_Control(pDX, IDC_EDIT1, m_edit);
    DDX_Control(pDX, IDC_EDIT3, m_static1);
    DDX_Control(pDX, IDC_OK, m_btnOK);
    DDX_Control(pDX, IDC_CANCEL, m_btnCancel);
}

BEGIN_MESSAGE_MAP(CUpdateImageDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
    ON_WM_SIZE()
#endif
    //}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_OK, &CUpdateImageDlg::OnBnClickedOk)
    ON_BN_CLICKED(IDC_CANCEL, &CUpdateImageDlg::OnBnClickedCancel)
    ON_BN_CLICKED(IDC_BUTTON1, &CUpdateImageDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CUpdateImageDlg message handlers

BOOL CUpdateImageDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);            // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    // TODO: Add extra initialization here
    m_static.SetWindowTextW(L"Please select the sb file path.");
    m_static1.SetWindowTextW(L"Click OK to process, click cancel to quit.");
    return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CUpdateImageDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    if (AfxIsDRAEnabled())
    {
        DRA::RelayoutDialog(
            AfxGetResourceHandle(), 
            this->m_hWnd, 
            DRA::GetDisplayMode() != DRA::Portrait ? 
            MAKEINTRESOURCE(IDD_UPDATEIMAGE_DIALOG_WIDE) : 
            MAKEINTRESOURCE(IDD_UPDATEIMAGE_DIALOG));
    }
}
#endif

extern BOOL DoUpdateSB(CUpdateImageDlg *dlg);
void CUpdateImageDlg::OnBnClickedOk()
{
    HANDLE temp;

    temp = CreateFile(m_filename.GetString(),            // name of device
                    GENERIC_READ|GENERIC_WRITE,         // desired access
                    0,                                  // non-sharing mode
                    NULL,                               // security attributes (ignored)
                    OPEN_EXISTING,                      // creation disposition
                    FILE_FLAG_RANDOM_ACCESS,            // flags/attributes
                    NULL);                              // template file (ignored)
    if(INVALID_HANDLE_VALUE == temp)                     
    {
        MessageBox(L"please input correct file path", 0, 0);
        return;
    }
    else
        CloseHandle(temp);
    // TODO: Add your control notification handler code here
    hThread = ::CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DoUpdateSB, this, 0, NULL);
    UpdateData(); 
    m_btnOK.EnableWindow(FALSE);
    m_btnCancel.EnableWindow(FALSE);
    m_static.SetWindowTextW(L"updating.......");
    m_static1.SetWindowTextW(L"please wait until reboot");
    m_edit.ShowWindow(SW_HIDE);
    m_process.ShowWindow(SW_SHOW);
    UpdateData(FALSE); 
}

void CUpdateImageDlg::OnBnClickedCancel()
{
    // TODO: Add your control notification handler code here
    CUpdateImageDlg::OnCancel();
}

void CUpdateImageDlg::OnBnClickedButton1()
{
    // TODO: Add your control notification handler code here
    
    UpdateData(); 
    LPCTSTR filters = _T("sb file(*.sb)|*.sb|All Files(*.*)|(*.*)"); 
    CFileDialog fileDlg(TRUE,_T("*.dat"),NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,filters); 

    int result=fileDlg.DoModal(); 
    if (result==IDOK) 
    { 
        m_filename = fileDlg.GetPathName();
        m_edit.SetWindowTextW(m_filename);
    }
    else 
    { 
        MessageBox(_T("no path input")); 
        return; 
    } 
    UpdateData(FALSE); 
}
